/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 *
 * @author hajo
 */
public class CommandLinePig {

    public static void main(String[] args) {
        new CommandLinePig().run();
    }

    private void run(){
        boolean done = false;
        Pig pig = buildPig();
        System.out.println("Pig started");
        System.out.print("Players are ");
        render(pig);
        Scanner s = new Scanner(System.in);
        System.out.println("Player is " + pig.getActualPlayer());
        while (!done) {
            System.out.print("> ");
            String cmd = s.nextLine();
            switch (cmd) {
                case "r":
                    int result = pig.roll();
                    System.out.println(result);
                    if (result == 1) {
                        render(pig);
                        pig.next();
                        System.out.println("Player is " + pig.getActualPlayer());
                    }
                    break;
                case "n":
                    pig.setTotal();
                    render(pig);
                    if (pig.gameOver()) {
                        done = true;
                    } else {
                        pig.next();
                        System.out.println("Player is " + pig.getActualPlayer());
                    }
                    break;
                case "q":
                    done = true;
                    break;
                default:
                    System.out.println("?");
            }       
        }
        if( pig.gameOver() ){
            System.out.println("Game over! Winner is " + pig.getActualPlayer());
        }else{
            render(pig);
            System.out.println("Game aborted");        
        }
    }

    private Pig buildPig(){
        PigDice dice = new PigDice(6);
        List<Player> players = new ArrayList<>();
        players.add(new Player("Anna", dice));
        players.add(new Player("Urban", dice));
        players.add(new Player("Fia", dice));

        return new Pig(players, dice, 20);
    }

    private void render(Pig pig) {
        for (Player p : pig.getPlayers()) {
            System.out.print(p + " ");
        }
        System.out.println();
    }

}
