import java.util.Random;

/**
 * A dice designed for Pig game (accumulating total)
 *
 * @author hajo
 */
public class PigDice {

    private final int faces;
    private final Random random = new Random();
    private int result;
    private int total;

    public PigDice(int faces) {
        this.faces = faces;
    }

    public int roll() {
        result = random.nextInt(faces) + 1;
        if (result > 1) {
            total += result;
        } else {
            total = 0;
        }
        return result;
    }

    public int getTotal() {
        return total;
    }


    public void clear() {
        total = 0;
    }
}
