import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * Command line version of Scrabble
 * NOTE: Program isn't finished
 */
public class CommandLineScrabble {

    public static void main(String[] args) {
        new CommandLineScrabble().run();
    }

    private void run() {
        Scrabble scrabble = buildScrabble();
        System.out.println("h for help on commands");
        Scanner s = new Scanner(System.in);
        boolean done = false;
        while (!done) {
            render(scrabble);
            System.out.println(scrabble.getActualPlayer());
            System.out.print("> ");
            String cmd = s.nextLine();
            switch (cmd) {
                case "h":
                    help();
                    break;
                case "q":
                    done = true;
                    break;
                case "p":
                    System.out.println("Put tile");
                    System.out.print("index for tile > ");
                    int index = Integer.parseInt(s.nextLine());
                    System.out.print("row > ");
                    int row = Integer.parseInt(s.nextLine());
                    System.out.print("col > ");
                    int col = s.nextInt();
                    scrabble.playerPutTile(row, col, index);
                    break;
                case "r":
                    System.out.println("Remove tile");
                    System.out.print("row > ");
                    row = Integer.parseInt(s.nextLine());
                    System.out.print("col > ");
                    col = Integer.parseInt(s.nextLine());
                    scrabble.playerRemoveTile(row, col);
                    break;
                case "n":
                    scrabble.nextPlayer();
                    break;
                default:
                    System.out.println("?");
            }
            if (scrabble.gameOver()) {
                done = true;
            }
        }
        System.out.println("Game over");
    }

    public Scrabble buildScrabble() {
        List<Tile> tiles = getTiles();
        TileBag bag = new TileBag(tiles);
        Board board = new Board(5, 5);
        List<Player> players = new ArrayList<>();
        players.add(new Player("olle", new Holder(4), bag));
        players.add(new Player("fia", new Holder(4), bag));
        return new Scrabble(players, bag, board, new WordBook());
    }

    private void render(Scrabble scrabble) {
        Tile[][] tiles = scrabble.getBoard().getTiles();
        for (int row = 0; row < tiles.length; row++) {
            for (int col = 0; col < tiles[row].length; col++) {
                if (tiles[row][col] == null) {
                    System.out.print("[   ]");
                } else {
                    System.out.print(tiles[row][col]);
                }
            }
            System.out.println();
        }
    }

    private void help() {
        System.out.println("q = quit");
        System.out.println("n = next player");
        System.out.println("p = put tile");
        System.out.println("r = remove tile");
    }

    // This should be read from file, just simplified
    // test data to use for now
    private List<Tile> getTiles() {
        String[] glyphs = "A1A1B2B2C3C3D2D2E1E1F1F1G1G1H1H1I2I2J2J2K1K1L2L2M1M1N1N1".split("");
        List<Tile> tiles = new ArrayList<>();
        for (int i = 0; i < glyphs.length - 1; i = i + 2) {
            Tile t = new Tile(glyphs[i], Integer.valueOf(glyphs[i + 1]));
            tiles.add(t);
        }
        return tiles;
    }
}
