import java.util.List;
import java.util.Random;

/**
 * A bag to pick tiles from
 *
 * @author hajo
 */
// Inv: tiles != null && r != null
public class TileBag {

    // Use a list to make bag shrimp, exactly what we want.
    private final List<Tile> tiles;
    private final Random r = new Random();

    public TileBag(List<Tile> tiles) {
        if (tiles == null) {
            throw new IllegalArgumentException("tiles may not be null");
        }
        this.tiles = tiles;
    }

    // Pre: tiles.size() > 0
    public Tile remove() {
        if (tiles.size() > 0) {
            int i = r.nextInt(tiles.size());
            return tiles.remove(i);
        } else {
            return null;
        }
    }

    public void add(Tile t) {
        tiles.add(t);
    }

    public boolean isEmpty() {
        return tiles.isEmpty();
    }

}
